/*
   Smartmeter P1 HelloWorld
   
   DSMR Protocol P1: https://www.netbeheernederland.nl/_upload/Files/Slimme_meter_15_a727fce1f1.pdf

   by noiasca

   2021-12-12 initial version
*/

#include <NoiascaSmartmeter.h>           // download from https://werner.rothschopf.net/

SmartmeterP1 smartmeter(Serial);         // use HW Serial if available

// The DSMR P1 protocol is specified for 115200 Baud.
// this exceeds the recommendation for AltSoftSerial (or any other Software Serial)
//#include <AltSoftSerial.h>
//AltSoftSerial altSerial;               // AltSoftSerial always uses RX = 8; TX = 9 on Uno/Nano.

// this function will be called each time we have received a new packet (= several lines)
void callbackOnNewData()
{
  Serial.println(F("new data available"));
  Serial.println(smartmeter.getActualElectricityPowerReceived());
}

// Arduino setup and loop
void setup() {
  Serial.begin(115200);
  Serial.println(F("Smartmeter P1 HelloWorld"));
  //altSerial.begin(115200);                  // start your interface (if necessary)
  smartmeter.setOnNewData(callbackOnNewData); // register a callback onNewData
}

void loop() {
  smartmeter.update();   // call the object in loop to read data
}
